! program transforms annual exposures on age at exposure scale to latency scale
!
! program requires array
!    age               attained age variable
! and
!    aae1, aae2, ...   annual exposures indexed by the age at the end of that year
! and returns array
!    tse1, tse2, ...   annual exposures indexed by the latency at the end of that year
!
! input
!    #maxtse   maximum latency for which annual exposure will be created
!    #maxaae   maximum age for which annual exposure is provided
!    #lag      lag interval
!
! M. Hauptmann, 8/00, suggestions to: hauptmann@nih.gov

NOQUERY@

!!**************************************************************************************
!! set log file name and constants
!LOG aae2tse.log@
!CONSTANT #maxtse =50;      ! maximum latency for which annual exposure will be created
!         #maxaae =80;      ! maximum age for which annual exposure is provided
!         #lag    =2@       ! lag interval
!!**************************************************************************************

TRAN tse1 =0; tse2 =0; tse3 =0; tse4 =0; tse5 =0; tse6 =0; tse7 =0; tse8 =0; tse9 =0; tse10=0; 
     tse11=0; tse12=0; tse13=0; tse14=0; tse15=0; tse16=0; tse17=0; tse18=0; tse19=0; tse20=0; 
     tse21=0; tse22=0; tse23=0; tse24=0; tse25=0; tse26=0; tse27=0; tse28=0; tse29=0; tse30=0; 
     tse31=0; tse32=0; tse33=0; tse34=0; tse35=0; tse36=0; tse37=0; tse38=0; tse39=0; tse40=0; 
     tse41=0; tse42=0; tse43=0; tse44=0; tse45=0; tse46=0; tse47=0; tse48=0; tse49=0; tse50=0; 
     tse51=0; tse52=0; tse53=0; tse54=0; tse55=0; tse56=0; tse57=0; tse58=0; tse59=0; tse60=0@
ARRAY \tse tse1 - tse60@
ARRAY \aae aae1 - aae80@

TRAN rstime=age-#lag;
     #i=1;
     DOWHILE #i<=#maxtse;
        err1=0;
        err2=0;
        ageind=FLOOR(rstime)-#i+1;

        IF 1<=ageind AND ageind<=#maxaae
           THEN \tse(#i)=\aae(ageind)
           ELSE \tse(#i)=0
        ENDIF;
        IF #i<1 OR #i>#maxtse THEN err1=1 ENDIF;
        IF ageind<1 OR ageind>#maxaae THEN err2=1 ENDIF;
        #i=#i+1;
     ENDDO@     

DROP \aae@
DROP aae1  aae2  aae3  aae4  aae5  aae6  aae7  aae8  aae9  aae10 
     aae11 aae12 aae13 aae14 aae15 aae16 aae17 aae18 aae19 aae20@
DROP aae21 aae22 aae23 aae24 aae25 aae26 aae27 aae28 aae29 aae30 
     aae31 aae32 aae33 aae34 aae35 aae36 aae37 aae38 aae39 aae40@
DROP aae41 aae42 aae43 aae44 aae45 aae46 aae47 aae48 aae49 aae50 
     aae51 aae52 aae53 aae54 aae55 aae56 aae57 aae58 aae59 aae60@
DROP aae61 aae62 aae63 aae64 aae65 aae66 aae67 aae68 aae69 aae70 
     aae71 aae72 aae73 aae74 aae75 aae76 aae77 aae78 aae79 aae80@
DROP #i #maxaae #maxtse #lag ageind rstime@

RETURN@


