! B-spline weight function model with B-splines of any order and any knots
!   order = order of spline (e.g., cubic, r=4)
!   m = # interior knots + order = number of basis functions
!   m + order = "total" knots
!
! M. Hauptmann, 7/00, suggestions to: hauptmann@nih.gov

! initialize arrays
!<c:\haupt\etr\epicure\bswf\arrays.cmd

!!**************************************************************************************
!! set number of interior knots (<=10) and knot locations
!!
!CONSTANT #a     =3;       ! end knot
!         #knot1 =22;      ! interior knots
!         #b     =40;      ! end knot
!         #knots =0;       ! number of interior knots
!         #order =4@       ! order of spline (2, 3 or 4, eg 4 for cubic spline)
!
!! identify exposure history array
!ARRAY \xt r_tse1-r_tse40@
!!
!!**************************************************************************************

! calculate spline knots
<c:\haupt\etr\epicure\bswf\knots.cmd

! initialize spline covariates B_{i,r}(t)*x(t)
TRAN #i=1;
     DOWHILE (#i<=#m);
        \bx(#i)=0.0;
        #i=#i+1;
     ENDDO@

! get spline covariates \sum_{t=a}^b B_{i,r}(t)*x(t)
CONSTANT #run=#b-#a+1@

WHILE #run DO c:\haupt\etr\epicure\bswf\bx1.cmd@

! clean up
DROP \kntint \knt \tm \b0 \b1 \bx@
DROP knot1 knot2 knot3 knot4 knot5@
DROP knot6 knot7 knot8 knot9 knot10@
DROP t1  t2  t3  t4  t5  t6  t7  t8  t9  t10@
DROP t11 t12 t13 t14 t15 t16 t17 t18 t19 t20@
DROP t21 t22 t23 t24 t25 t26 t27 t28 t29 t30@
DROP t31 t32 t33 t34 t35 t36 t37 t38 t39 t40@
DROP t41 t42 t43 t44 t45 t46 t47 t48 t49 t50@
DROP t51 t52 t53 t54 t55 t56 t57 t58 t59 t60@
DROP t61 t62 t63 t64 t65 t66 t67 t68 t69 t70@
DROP t71 t72 t73 t74 t75 t76 t77 t78 t79 t80@
DROP t81 t82 t83 t84 t85 t86 t87 t88 t89 t90@
DROP t91 t92 t93 t94 t95 t96@
DROP b01 b02 b03 b04 b05 b06 b07 b08 b09 b010 b011 b012@
DROP b11 b12 b13 b14 b15 b16 b17 b18 b19 b110 b111 b112@
DROP #temp #run #i #j #t@
DROP #r #index #sumb #mr@

NOMODEL@
LINE 1 %CON bx1 bx2 bx3 bx4 bx5 bx6 bx7 bx8 bx9 bx10 bx11 bx12@

! fit model that includes the B-spline basis functions
! bx1 bx2 bx3 ...
! as parameters no. 2, 3, 4, ...
!
! for Wald confidence limits:
! run script ci_wald.cmd
!
! for approximate interpolated LR confidence:
! specify your model in file ci_lr1.cmd
! and run script ci_lr.cmd
!
! for bootstrap replicates of weight function estimates:
! specify number of bootstrap samples in file ci_btsp.cmd
! and weight function model in file ci_btsp3.cmd run script
! ci_btsp.cmd

RETURN@

