function s=splot(sp,r,t)
% s=splot(sp,r,t): plots spline from EPICURE report file
%
% sp     results from EPICURE program ci.cmd
% r      risk type, err = excess additive risk, or = odds ratio
% t      time scale, tse = time since exposure, aae = age at exposure

%figure('name',['Estimated spline with pointwise 95% CI']);
   
ma=sp(find(sp(:,2)==max(sp(:,2))),1);
   
switch r
   case 'or'
      plot(sp(:,1),exp(sp(:,2)),'-',sp(:,1),exp(sp(:,4)),'--',sp(:,1),exp(sp(:,5)),'--');
      hold on
         ylabel('OR','VerticalAlignment','Bottom','FontSize',16);   
         % plot reference line at 1
         plot(sp(:,1),ones(size(sp,1),1),'k--');
   case 'err'
      plot(sp(:,1),sp(:,2),'-',sp(:,1),sp(:,4),'--',sp(:,1),sp(:,5),'--');
      hold on
         ylabel('ERR','VerticalAlignment','Bottom','FontSize',16);   
         % plot reference line at 0
         plot(sp(:,1),zeros(size(sp,1),1),'k--');
   otherwise
      error('Risk type (second input argument) must be err or or.');
end      
         
switch t
   case 'tse'
         % axes labels
         xlabel('Time since exposure (years)','VerticalAlignment','Top','FontSize',16);   
   case 'aae'
         % axes labels
         xlabel('Age at exposure (years)','VerticalAlignment','Top','FontSize',16);   
   otherwise
      error('Time scale (third input argument) must be tse or aae.');
end      
         
         set(gca,'FontSize',16);
      
      hold off;